/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   string.cpp
 * Author: jbatista
 * 
 * Created on 2 de Abril de 2019, 15:17
 */

#include "String.h"
#include <iostream>
#include <cstring>
#include <cassert>
#include <valarray>

using namespace std;

String::String(){
    length = 100;
    str = new char[length];
}


String::String(const char *s) {
    cout << "construtor de conversao...\n";
    length = strlen(s);
    str = new char[length+1];
    strncpy(str, s, length);
}

// construtor copia..... !!!!
String::String(const String& orig) {
    cout << "construtor copia...\n";
    length = orig.length;
    str = new char[length+1];
    strncpy(str, orig.str, length);
}

String::~String() {
    cout << "destruindo a string = " << this->getString() << endl;
    delete str;
}

char *String::getString(){
    return str;
}

//Operadores de sobrecarga
String &String::operator=(const String& dir) {
    if (&dir != this){ // a = a nao precisa fazer nada !!!!!
        delete str; // apaga a string antiga e evita desperdicio de memoria....
        length = dir.length;
        str = new char[length+1];
        strncpy(str, dir.str, length);
        str[length] = '\0';
    }
    
    return *this;
}

bool String::operator ==(const String& dir){
    return strcmp(str, dir.str) == 0;
}

ostream &operator<<(ostream &output, const String & dir){
    output << dir.str;
    return output;
}